xv6-cs450/Makefile

245 lines
6.3 KiB
Makefile
Raw Normal View History

2006-07-16 17:35:18 +02:00
OBJS = \
2007-08-28 06:20:40 +02:00
bio.o\
2006-07-16 17:35:18 +02:00
console.o\
2007-08-28 06:20:40 +02:00
exec.o\
2006-09-06 20:40:28 +02:00
file.o\
2007-08-28 06:20:40 +02:00
fs.o\
2006-07-16 17:35:18 +02:00
ide.o\
2007-08-28 06:20:40 +02:00
ioapic.o\
2006-07-16 17:35:18 +02:00
kalloc.o\
2007-08-28 06:20:40 +02:00
kbd.o\
2006-07-16 17:35:18 +02:00
lapic.o\
main.o\
mp.o\
picirq.o\
pipe.o\
proc.o\
spinlock.o\
string.o\
2007-08-28 14:48:33 +02:00
swtch.o\
2006-07-16 17:35:18 +02:00
syscall.o\
2006-09-06 20:18:43 +02:00
sysfile.o\
sysproc.o\
2007-08-28 06:41:20 +02:00
timer.o\
2006-07-16 17:35:18 +02:00
trapasm.o\
trap.o\
uart.o\
2006-07-16 17:35:18 +02:00
vectors.o\
vm.o\
2006-06-12 17:22:12 +02:00
2006-07-11 03:07:40 +02:00
# Cross-compiling (e.g., on Mac OS X)
2010-08-31 21:01:26 +02:00
#TOOLPREFIX = i386-jos-elf-
2006-07-11 03:07:40 +02:00
# Using native tools (e.g., on X86 Linux)
#TOOLPREFIX =
2006-07-11 03:07:40 +02:00
2010-08-31 21:01:26 +02:00
# Try to infer the correct TOOLPREFIX if not set
ifndef TOOLPREFIX
TOOLPREFIX := $(shell if i386-jos-elf-objdump -i 2>&1 | grep '^elf32-i386$$' >/dev/null 2>&1; \
then echo 'i386-jos-elf-'; \
elif objdump -i 2>&1 | grep 'elf32-i386' >/dev/null 2>&1; \
then echo ''; \
else echo "***" 1>&2; \
echo "*** Error: Couldn't find an i386-*-elf version of GCC/binutils." 1>&2; \
echo "*** Is the directory with i386-jos-elf-gcc in your PATH?" 1>&2; \
echo "*** If your i386-*-elf toolchain is installed with a command" 1>&2; \
echo "*** prefix other than 'i386-jos-elf-', set your TOOLPREFIX" 1>&2; \
echo "*** environment variable to that prefix and run 'make' again." 1>&2; \
echo "*** To turn off this error, run 'gmake TOOLPREFIX= ...'." 1>&2; \
echo "***" 1>&2; exit 1; fi)
endif
2010-08-31 21:05:27 +02:00
# If the makefile can't find QEMU, specify its path here
#QEMU =
# Try to infer the correct QEMU
ifndef QEMU
QEMU = $(shell if which qemu > /dev/null; \
then echo qemu; exit; \
else \
qemu=/Applications/Q.app/Contents/MacOS/i386-softmmu.app/Contents/MacOS/i386-softmmu; \
if test -x $$qemu; then echo $$qemu; exit; fi; fi; \
echo "***" 1>&2; \
echo "*** Error: Couldn't find a working QEMU executable." 1>&2; \
echo "*** Is the directory containing the qemu binary in your PATH" 1>&2; \
echo "*** or have you tried setting the QEMU variable in Makefile?" 1>&2; \
echo "***" 1>&2; exit 1)
endif
2006-07-11 03:07:40 +02:00
CC = $(TOOLPREFIX)gcc
2007-08-28 06:20:40 +02:00
AS = $(TOOLPREFIX)gas
2006-07-11 03:07:40 +02:00
LD = $(TOOLPREFIX)ld
OBJCOPY = $(TOOLPREFIX)objcopy
OBJDUMP = $(TOOLPREFIX)objdump
CFLAGS = -fno-pic -static -fno-builtin -fno-strict-aliasing -O2 -Wall -MD -ggdb -m32 -Werror
2007-08-28 06:20:40 +02:00
CFLAGS += $(shell $(CC) -fno-stack-protector -E -x c /dev/null >/dev/null 2>&1 && echo -fno-stack-protector)
2009-10-05 19:20:23 +02:00
ASFLAGS = -m32 -gdwarf-2
2007-09-20 01:49:52 +02:00
# FreeBSD ld wants ``elf_i386_fbsd''
LDFLAGS += -m $(shell $(LD) -V | grep elf_i386 2>/dev/null)
2006-06-12 17:22:12 +02:00
2007-08-28 06:20:40 +02:00
xv6.img: bootblock kernel fs.img
2006-06-12 17:22:12 +02:00
dd if=/dev/zero of=xv6.img count=10000
dd if=bootblock of=xv6.img conv=notrunc
dd if=kernel of=xv6.img seek=1 conv=notrunc
2007-08-28 06:20:40 +02:00
bootblock: bootasm.S bootmain.c
$(CC) $(CFLAGS) -fno-pic -O -nostdinc -I. -c bootmain.c
$(CC) $(CFLAGS) -fno-pic -nostdinc -I. -c bootasm.S
$(LD) $(LDFLAGS) -N -e start -Ttext 0x7C00 -o bootblock.o bootasm.o bootmain.o
2006-06-12 17:22:12 +02:00
$(OBJDUMP) -S bootblock.o > bootblock.asm
2009-09-02 08:03:46 +02:00
$(OBJCOPY) -S -O binary -j .text bootblock.o bootblock
2006-06-12 17:22:12 +02:00
./sign.pl bootblock
2007-08-28 06:20:40 +02:00
bootother: bootother.S
$(CC) $(CFLAGS) -nostdinc -I. -c bootother.S
$(LD) $(LDFLAGS) -N -e start -Ttext 0x7000 -o bootother.out bootother.o
$(OBJCOPY) -S -O binary bootother.out bootother
$(OBJDUMP) -S bootother.o > bootother.asm
2007-08-28 06:20:40 +02:00
initcode: initcode.S
$(CC) $(CFLAGS) -nostdinc -I. -c initcode.S
$(LD) $(LDFLAGS) -N -e start -Ttext 0 -o initcode.out initcode.o
$(OBJCOPY) -S -O binary initcode.out initcode
$(OBJDUMP) -S initcode.o > initcode.asm
2007-08-28 06:20:40 +02:00
kernel: $(OBJS) bootother initcode
$(LD) $(LDFLAGS) -Ttext 0x100000 -e main -o kernel $(OBJS) -b binary initcode bootother
2006-06-12 17:22:12 +02:00
$(OBJDUMP) -S kernel > kernel.asm
2007-08-28 14:48:33 +02:00
$(OBJDUMP) -t kernel | sed '1,/SYMBOL TABLE/d; s/ .* / /; /^$$/d' > kernel.sym
2006-06-12 17:22:12 +02:00
2006-09-07 16:10:52 +02:00
tags: $(OBJS) bootother.S _init
etags *.S *.c
2007-08-28 06:20:40 +02:00
vectors.S: vectors.pl
2006-06-13 17:50:06 +02:00
perl vectors.pl > vectors.S
ULIB = ulib.o usys.o printf.o umalloc.o
2006-07-11 03:07:40 +02:00
2007-08-28 06:20:40 +02:00
_%: %.o $(ULIB)
$(LD) $(LDFLAGS) -N -e main -Ttext 0 -o $@ $^
2007-08-28 06:20:40 +02:00
$(OBJDUMP) -S $@ > $*.asm
2007-08-28 14:48:33 +02:00
$(OBJDUMP) -t $@ | sed '1,/SYMBOL TABLE/d; s/ .* / /; /^$$/d' > $*.sym
2007-08-08 10:38:55 +02:00
2007-08-24 22:20:23 +02:00
_forktest: forktest.o $(ULIB)
# forktest has less library code linked in - needs to be small
# in order to be able to max out the proc table.
$(LD) $(LDFLAGS) -N -e main -Ttext 0 -o _forktest forktest.o ulib.o usys.o
2007-08-24 22:20:23 +02:00
$(OBJDUMP) -S _forktest > forktest.asm
2007-08-28 06:20:40 +02:00
mkfs: mkfs.c fs.h
gcc -m32 -Werror -Wall -o mkfs mkfs.c
2007-08-28 06:20:40 +02:00
UPROGS=\
_cat\
2007-08-28 06:26:34 +02:00
_echo\
2007-08-28 06:20:40 +02:00
_forktest\
2007-08-28 06:26:34 +02:00
_grep\
2007-08-28 06:20:40 +02:00
_init\
_kill\
_ln\
_ls\
_mkdir\
_rm\
_sh\
_stressfs\
2007-08-28 06:20:40 +02:00
_usertests\
_wc\
_zombie\
fs.img: mkfs README $(UPROGS)
2007-08-08 10:38:55 +02:00
./mkfs fs.img README $(UPROGS)
2006-06-15 21:58:01 +02:00
-include *.d
2007-08-28 06:20:40 +02:00
clean:
2007-08-30 20:33:48 +02:00
rm -f *.tex *.dvi *.idx *.aux *.log *.ind *.ilg \
2007-08-28 06:20:40 +02:00
*.o *.d *.asm *.sym vectors.S parport.out \
2007-08-08 10:38:55 +02:00
bootblock kernel xv6.img fs.img mkfs \
$(UPROGS)
2006-09-07 22:06:15 +02:00
# make a printout
2007-08-30 16:12:19 +02:00
FILES = $(shell grep -v '^\#' runoff.list)
2010-08-31 23:30:31 +02:00
PRINT = runoff.list runoff.spec $(FILES)
2006-09-07 22:06:15 +02:00
2007-08-28 06:20:40 +02:00
xv6.pdf: $(PRINT)
2006-09-07 22:06:15 +02:00
./runoff
ls -l xv6.pdf
2006-09-07 22:06:15 +02:00
2007-08-28 06:20:40 +02:00
print: xv6.pdf
2006-09-07 22:06:15 +02:00
# run in emulators
bochs : fs.img xv6.img
if [ ! -e .bochsrc ]; then ln -s dot-bochsrc .bochsrc; fi
bochs -q
2009-09-15 23:15:36 +02:00
# try to generate a unique GDB port
GDBPORT = $(shell expr `id -u` % 5000 + 25000)
# QEMU's gdb stub command line changed in 0.11
2010-08-31 21:05:27 +02:00
QEMUGDB = $(shell if $(QEMU) -help | grep -q '^-gdb'; \
then echo "-gdb tcp::$(GDBPORT)"; \
else echo "-s -p $(GDBPORT)"; fi)
ifndef CPUS
CPUS := 2
endif
QEMUOPTS = -hdb fs.img xv6.img -smp $(CPUS)
2009-09-15 23:15:36 +02:00
2007-08-28 06:20:40 +02:00
qemu: fs.img xv6.img
2010-08-31 21:05:27 +02:00
$(QEMU) -serial mon:stdio $(QEMUOPTS)
2006-09-07 22:06:15 +02:00
2009-10-01 04:09:48 +02:00
qemu-nox: fs.img xv6.img
2010-08-31 21:05:27 +02:00
$(QEMU) -nographic $(QEMUOPTS)
2009-09-15 23:15:36 +02:00
.gdbinit: .gdbinit.tmpl
sed "s/localhost:1234/localhost:$(GDBPORT)/" < $^ > $@
qemu-gdb: fs.img xv6.img .gdbinit
@echo "*** Now run 'gdb'." 1>&2
2010-08-31 21:05:27 +02:00
$(QEMU) -serial mon:stdio $(QEMUOPTS) -S $(QEMUGDB)
qemu-nox-gdb: fs.img xv6.img .gdbinit
2009-10-01 04:09:48 +02:00
@echo "*** Now run 'gdb'." 1>&2
2010-08-31 21:05:27 +02:00
$(QEMU) -nographic $(QEMUOPTS) -S $(QEMUGDB)
2009-10-01 04:09:48 +02:00
2006-09-08 16:41:06 +02:00
# CUT HERE
# prepare dist for students
# after running make dist, probably want to
# rename it to rev0 or rev1 or so on and then
# check in that version.
2007-08-30 16:12:19 +02:00
EXTRA=\
2009-11-23 23:50:58 +01:00
mkfs.c ulib.c user.h cat.c echo.c forktest.c grep.c kill.c\
ln.c ls.c mkdir.c rm.c stressfs.c usertests.c wc.c zombie.c\
printf.c umalloc.c\
2007-08-30 16:12:19 +02:00
README dot-bochsrc *.pl toc.* runoff runoff1 runoff.list\
2009-11-23 23:50:58 +01:00
.gdbinit.tmpl gdbutil\
2007-08-30 16:12:19 +02:00
2007-08-28 06:20:40 +02:00
dist:
2006-09-08 16:41:06 +02:00
rm -rf dist
mkdir dist
2009-11-23 23:50:58 +01:00
for i in $(FILES); \
2006-09-08 16:41:06 +02:00
do \
grep -v PAGEBREAK $$i >dist/$$i; \
done
sed '/CUT HERE/,$$d' Makefile >dist/Makefile
2007-08-30 16:12:19 +02:00
echo >dist/runoff.spec
cp $(EXTRA) dist
2006-09-08 16:41:06 +02:00
2007-08-28 06:20:40 +02:00
dist-test:
2007-08-30 16:12:19 +02:00
rm -rf dist
make dist
2006-09-08 16:41:06 +02:00
rm -rf dist-test
mkdir dist-test
cp dist/* dist-test
cd dist-test; ../m print
cd dist-test; ../m bochs || true
cd dist-test; ../m qemu
2007-08-28 06:20:40 +02:00
# update this rule (change rev1) when it is time to
2006-09-08 16:41:06 +02:00
# make a new revision.
2007-08-28 06:20:40 +02:00
tar:
2006-09-08 16:41:06 +02:00
rm -rf /tmp/xv6
mkdir -p /tmp/xv6
2009-09-16 01:15:59 +02:00
cp dist/* dist/.gdbinit.tmpl /tmp/xv6
2010-09-03 21:47:28 +02:00
(cd /tmp; tar cf - xv6) | gzip >xv6-rev4.tar.gz